summaryrefslogtreecommitdiffstats
path: root/gnash
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2009-09-29 14:28:23 +0000
committer Eric Hameleers <alien@slackware.com>2009-09-29 14:28:23 +0000
commit6eeef88d1ef7aa1535e8def61d302ae8ce8c8175 (patch)
tree77ba29c2ff847fbf0f6aad446f41a67014f22493 /gnash
parent0f608378f948b4067d2f968d5460de1d861fd724 (diff)
downloadasb-6eeef88d1ef7aa1535e8def61d302ae8ce8c8175.tar.gz
asb-6eeef88d1ef7aa1535e8def61d302ae8ce8c8175.tar.xz
The SlackBuild script for gnash is brought to new standards
Diffstat (limited to 'gnash')
-rwxr-xr-xgnash/build/gnash.SlackBuild326
1 files changed, 155 insertions, 171 deletions
diff --git a/gnash/build/gnash.SlackBuild b/gnash/build/gnash.SlackBuild
index 73154d5a..eba6cdcc 100755
--- a/gnash/build/gnash.SlackBuild
+++ b/gnash/build/gnash.SlackBuild
@@ -1,94 +1,126 @@
#!/bin/sh
-# Copyright (c) 2006 Eric Hameleers <alien@slackware.com>
-# Distributed under the terms of the GNU General Public License, Version 2
+# $Id$
+# Copyright (c) 2009 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script
# ===========================
-# By: Eric Hameleers <alien@slackware.com>
-# For: gnash
-# URL: http://www.gnu.org/software/gnash/
-# Needs: OpenGL, SDL, libxml2
-# Changelog:
-# 20060110-1:10/jan/2006 by Eric Hameleers <alien@slackware.com>
-# * Initial build.
+# By: Eric Hameleers <alien@slackware.com>
+# For: gnash
+# Descr: GNU Flash movie player
+# URL: http://www.gnu.org/software/gnash/
+# Needs:
+# Changelog:
+# 20060110-1: 10/jan/2006 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+# 0.8.6-1: 29/Sep/2009 by Eric Hameleers <alien@slackware.com>
+# * Update, long overdue.
#
-# Run 'sh SlackBuild --cleanup' to build a Slackware package.
-# The package (.tgz) plus descriptive .txt file are created in /tmp .
-# Install using 'installpkg'.
+# Run 'sh gnash.SlackBuild' to build a Slackware package.
+# The package (.tgz) and .txt file as well as build logs are created in /tmp .
+# Install it using 'installpkg'.
#
# -----------------------------------------------------------------------------
-# --- INIT ---
# Set initial variables:
-CWD=`pwd`
-if [ "$TMP" = "" ]; then
- TMP=/tmp
-fi
PRGNAM=gnash
-VERSION=20060110
+VERSION=${VERSION:-0.8.6}
ARCH=${ARCH:-i486}
-BUILD=1
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:" -j4 "}
+TAG=${TAG:-alien}
-DOCS="AUTHORS COPYING ChangeLog NEWS README"
+# Do not ship megabytes of ChangeLog files:
+DOCS="ABOUT-NLS AUTHORS COPYING NEWS README TODO"
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
-# If you have more source files, list them here as SOURCE[1], SOURCE[2], etc.
-# If you know the URL for a source file, you can put that into the SRCURL[]
-# variable, and the SlackBuild script will try to download it for you.
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
-SOURCE[0]="${PRGNAM}-${VERSION}.tar.gz"
-SRCURL[0]=""
+SOURCE[0]="$SRCDIR/${PRGNAM}-${VERSION}.tar.bz2"
+SRCURL[0]="http://ftp.gnu.org/pub/gnu/${PRGNAM}/${VERSION}/${PRGNAM}-${VERSION}.tar.bz2"
##
## --- with a little luck, you won't have to edit below this point --- ##
##
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
case "$ARCH" in
- i386) SLKCFLAGS="-O2 -march=i386 -mcpu=i686" ;;
- i486) SLKCFLAGS="-O2 -march=i486 -mcpu=i686" ;;
- s390) SLKCFLAGS="-O2" ;;
- powerpc) SLKCFLAGS="-O2" ;;
- x86_64) SLKCFLAGS="-O2 -fPIC"; LIBDIRSUFFIX="64" ;;
- athlon-xp) SLKCFLAGS="-march=athlon-xp -O3 -pipe -fomit-frame-pointer"
+ i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ s390) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ powerpc) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
esac
-PKG=$TMP/package-$PRGNAM
-
-if [ ! -d $TMP/tmp-$PRGNAM ]; then
- mkdir -p $TMP/tmp-$PRGNAM # location to build the source
-elif [ "$1" != "--oldbuild" ]; then
- # If the "--oldbuild" parameter is present, we keep
- # the old build files and continue;
- # By default we remove the remnants of previous build and continue:
- rm -rf $TMP/tmp-$PRGNAM/*
-fi
-
-if [ ! -d $PKG ]; then
- mkdir -p $PKG # place for the package to be built
-fi
-
-
-# --- SOURCE FILE AVAILABILITY ---
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{configure,make,install,error,makepkg}-$PRGNAM.log
+ # remove old log files
+# Source file availability:
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
- if ! [ -f ${CWD}/${SOURCE[$i]} ]; then
- if ! [ "${SRCURL[$i]}" = "" ]; then
- echo "Source '${SOURCE[$i]}' not available yet... will download now:"
- wget -nv -O "${CWD}/${SOURCE[$i]}" "${SRCURL[$i]}"
- if [ $? -ne 0 ]; then
- echo "Downloading '${SOURCE[$i]}' failed... aborting the build."
+ if ! [ -f ${SOURCE[$i]} ]; then
+ if ! [ "x${SRCURL[$i]}" == "x" ]; then
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
+ echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
+ echo "Will download file to $(dirname $SOURCE[$i])"
+ wget -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
+ echo "Downloading '$(basename ${SOURCE[$i]})' failed.. aborting the build."
+ mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
exit 1
fi
else
- echo "File '${SOURCE[$i]}' not available... aborting the build."
+ echo "File '$(basename ${SOURCE[$i]})' not available.. aborting the build."
exit 1
fi
fi
done
-if [ "$1" == "--download" ]; then
+if [ "$P1" == "--download" ]; then
echo "Download complete."
exit 0
fi
@@ -99,139 +131,91 @@ echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"
-# Safety net 8-)
-if [ "$PKG" = "" -o "$PKG" = "/" ] ; then
- cat <<-EOT
- Your script sucks!!!
- You were about to delete the contents of your computer's hard disk!
- Please provide a value for the variable 'PKG'.
- EOT
- exit 1
-fi
-# We always erase old package's contents:
-rm -rf $PKG/*
-
-cd $PKG
-
-# Explode the package framework:
-if [ -f $CWD/_$PRGNAM.tar.gz ]; then
- explodepkg $CWD/_$PRGNAM.tar.gz
-fi
-
cd $TMP/tmp-$PRGNAM
-
-
-# --- TARBALL EXTRACTION,PATCH,MODIFY ---
-
-echo "Extracting the program tarball(s) for $PRGNAM..."
+echo "Extracting the source archive(s) for $PRGNAM..."
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
- if `file $CWD/${SOURCE[$i]} | grep -q ": bzip2"`; then
- tar -xjvf $CWD/${SOURCE[$i]}
- elif `file $CWD/${SOURCE[$i]} | grep -qi ": zip"`; then
- unzip $CWD/${SOURCE[$i]}
- else
- tar -xzvf $CWD/${SOURCE[$i]}
- fi
+ tar -xvf ${SOURCE[$i]}
done
cd ${PRGNAM}-${VERSION}
-patch -p1 <$CWD/plugin_makefiles.patch 2>&1 | tee $CWD/patch-${PRGNAM}.log
-
-chown -R root.root *
-find . -perm 777 -exec chmod 755 {} \;
-
-
-# --- BUILDING ---
+chown -R root:root .
+chmod -R u+w,go+r-w,a-s .
echo Building ...
-
-CFLAGS="$SLKCFLAGS" \
-./autogen.sh
+LDFLAGS="$SLKLDFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
CFLAGS="$SLKCFLAGS" \
-./configure --prefix=/usr \
- --localstatedir=/var \
- --sysconfdir=/etc \
- --enable-http \
- --enable-mp3 \
- --enable-plugin \
- --with-firefox-libraries=/usr/lib/firefox \
- 2>&1 | tee $CWD/configure-${PRGNAM}.log
-make 2>&1 | tee $CWD/make-${PRGNAM}.log
-
-#
-# Install all the needed stuff to the package dir
-#
-mkdir -p $PKG/usr/lib/firefox/plugins
-mkdir -p $PKG/usr/lib/mozilla/plugins
-
-# Use installwatch if available:
-which installwatch > /dev/null 2>&1
-if [ $? == 0 ]; then
- installwatch -o $CWD/install-${PRGNAM}.log make DESTDIR=$PKG install
-else
- make DESTDIR=$PKG install 2>&1 |tee $CWD/install-${PRGNAM}.log
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --localstatedir=/var \
+ --sysconfdir=/etc \
+ --enable-gui=gtk,kde4 \
+ --enable-renderer=cairo \
+ --enable-sound=sdl \
+ --enable-media=gst \
+ --with-plugins-install=system \
+ --with-npapi-install=system \
+ --with-npapi-plugindir=/usr/lib${LIBDIRSUFFIX}/mozilla/plugins \
+ --enable-xpcom \
+ --program-prefix= \
+ --program-suffix= \
+ --build=$ARCH-slackware-linux \
+ 2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
+
+make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+make DESTDIR=$PKG install install-plugins \
+ 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+
+# Add this to the doinst.sh:
+! [ -d $PKG/install ] && mkdir -p $PKG/install
+cat <<EOT >> $PKG/install/doinst.sh
+# Update the desktop database:
+if [ -x usr/bin/update-desktop-database ]; then
+ chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
fi
-cp -a $PKG/usr/lib/firefox/plugins/*.so $PKG/usr/lib/mozilla/plugins/
-
-
-# --- DOCUMENTATION ---
+EOT
+# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-cp -a $DOCS \
- $PKG/usr/doc/$PRGNAM-$VERSION
-chmod -R a-w $PKG/usr/doc/$PRGNAM-$VERSION/*
-
-# Move incorrectly installed man pages, if any
-[ -d $PKG/usr/share/man ] && \
- mv $PKG/usr/share/man $PKG/usr/ && rmdir $PKG/usr/share
-# Compress the man page(s)
-gzip -9f $PKG/usr/man/*/* 2>/dev/null
-gzip -9f $PKG/usr/man/*/*/* 2>/dev/null
-
-# Strip binaries
-( cd $PKG
- find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
- find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
-)
-
-
-# --- OWNERSHIP, RIGHTS ---
-
-chmod -R o-w $PKG
-chown root:bin $PKG/usr/bin/* $PKG/usr/sbin/* $PKG/bin/* $PKG/sbin/* \
- $PKG/usr/X11R6/bin/* $PKG/opt/kde/bin/* 2>/dev/null
-
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) | sed \
+ -e "/^VERSION=/s/:-.*}/:-$VERSION}/" \
+ -e "/^ARCH=/s/:-.*}/:-$ARCH}/" \
+ -e "/^BUILD=/s/:-.*}/:-$BUILD}/" \
+ > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
-# --- PACKAGE DESCRIPTION ---
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+# Add a package description:
mkdir -p $PKG/install
-cat $CWD/slack-desc > $PKG/install/slack-desc
-if [ -f $CWD/doinst.sh ]; then
- cat $CWD/doinst.sh > $PKG/install/doinst.sh
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+if [ -f $SRCDIR/doinst.sh ]; then
+ cat $SRCDIR/doinst.sh >> $PKG/install/doinst.sh
fi
-# I give in :-/
-if [ -f $CWD/slack-requires ]; then
- cat $CWD/slack-requires > $PKG/install/slack-requires
+if [ -f $SRCDIR/slack-required ]; then
+ cat $SRCDIR/slack-required > $PKG/install/slack-required
fi
-
-# --- BUILDING ---
-
# Build the package:
cd $PKG
-makepkg --linkadd y --chown n $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz \
- 2>&1 | tee $CWD/makepkg-${PRGNAM}.log
-(cd $TMP && md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5)
-cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
-if [ -f $PKG/install/slack-requires ]; then
- cat $PKG/install/slack-requires > $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.dep
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+if [ -f $PKG/install/slack-required ]; then
+ cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
fi
-
-# --- CLEANUP ---
-
-# Clean up the extra stuff:
-if [ "$1" = "--cleanup" ]; then
- rm -rf $TMP/tmp-$PRGNAM
- rm -rf $PKG
-fi